C     Program WPPF (ver.1.12) for whole-powder-pattern decomposition
C        without using a structural model.
C     The split-type Pearson VII and pseudo-Voigt functions
C        are used to approximate profile shape.
C     This program was written by Hideo TORAYA in 1985 (1.0), and
C        reviced in 1987 (1.1).
C     No part of this program may be used without permission of author.
C     Reference: J. Appl. cryst., vol.19, 440-447 (1986)
C
      CHARACTER TIT*70
  101 FORMAT(A70)
  211 FORMAT(
     ./' *************************************************************'
     ./' * W   W   W PPPPPP  PPPPPP  FFFFFFF   Computer Program for  *'
     ./' * W   W   W P     P P     P F         Whole-Powder-Pattern  *'
     ./' *  W W W W  PPPPPP  PPPPPP  FFFFFF    Decomposition (1.12)  *'
     ./' *  W W W W  P       P       F                               *'
     ./' *   W   W   P       P       F                  By H.Toraya  *'
     ./' *************************************************************')
  212 FORMAT(//' Input job title in 70 characters.')
  213 FORMAT(//' Select a print output mode for parameter changes.'//5X,
     . '0: no output,   1: output,   2: for parameter change > e.s.d.')
  214 FORMAT(' ********* Whole-Powder-Pattern Fitting by WPPF (ver. 1.12
     .) *************'//2X,A70)
  221 FORMAT(//' Select a input mode for initial parameters'
     . //5X,'0: input from data file,   1: generate new parameters.')
  231 FORMAT(//' ********** Optimization was started **********')
  232 FORMAT(//' Select:'
     .//5X,'0: CRT display of pattern fitting result,   1: no display.')
  241 FORMAT(//' Select:'//4X,
     . '-1: continue refinement,'/5X,'0: change the initial setting,'
     . /5X,'1: renew the intensity data,'/5X,'2: end of job.')
  242 FORMAT(/' ********** End of single job ***************************
     .****************')
  243 FORMAT(//' File name for print output = WPPF OUT.')
C
      NJOB=1
      OPEN(21,FILE='/WPPF OUT A1',STATUS='unknown')
      WRITE(*,211)
   11 WRITE(*,212)
      READ( *,101) TIT
      WRITE(*,213)
      READ( *,*) NCHA
      WRITE(21,214) TIT
C
      CALL DATAIN (STEP,RA12)
C
   21 CALL PROCES (NOBS,PMAX,STEP)
C
      WRITE(*,221)
      READ(*,*) NMOD
      IF(NMOD.EQ.0) THEN
C
      CALL PARAME
C
      ELSE
C
      CALL GENERA (RA12)
C
      END IF
C
   22 CALL CORECT (IJOB,NSET,PMAX,DRPF,GRUP)
C
      IF(IJOB.LT.0) GO TO 41
      WRITE(*,231)
      NRED=1
      LCYL=0
      NC=0
   31 NC=NC+1
C
      CALL ARANGE
C
      CALL GROUP
C
      IF(NRED-1) 34,32,33

   32 CALL SELECT (NC,NRED,NVAR,NXRP,NONL,NSET,GRUP)
C
      GO TO 34
   33 NRED=NRED-1
C
   34 CALL REFLEX (LCYL,NONL,DRPF,STEP)
C
      CALL MATRIX (NC,LCYL,NCHA,NOBS,NVAR,NXRP,NONL)
C
      IF(LCYL.GT.1) GO TO 35
C
      CALL CHANGE (NC,LCYL,NVAR,NCHA,NRED)
C
      CALL BUNKAI
C
      IF(LCYL.GE.0) GO TO 31
C
   35 WRITE(*,232)
      READ(*,*) NDIS
C
      IF(NDIS.EQ.0) CALL DISPLY (NOBS)
C
      CALL OUTPUT
C
   41 WRITE(*,241)
      READ(*,*) NJOB
      IF(NJOB.GE.2) GO TO 42
      IF(NJOB) 22,21,11
   42 WRITE(21,242)
      CLOSE(21)
      WRITE(*,243)
      STOP
      END
C
C
C
      SUBROUTINE ARANGE
C     Rearrangement of reflection in increasing order of d*
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/
C
      DO 12 K=1,NCOM
      LA=LAUE(K)
      AA=XPP(K,1)
      BB=XPP(K,2)
      CC=XPP(K,3)
      CA=0.0
      CB=0.0
      CG=0.0
      SA=1.0
      SB=1.0
      SG=1.0
      GA=0.0
      GB=0.0
      GG=0.0
      IF(LA.GT.3.AND.LA.LT.9) GO TO 11
      IF(LA.NE.3) THEN
        CG=COS(RAD*XPP(K,6))
        SG=SIN(RAD*XPP(K,6))
        GG=CA*CB-CG
      END IF
      IF(LA.EQ.2.OR.LA.GT.10) GO TO 11
      CB=COS(RAD*XPP(K,5))
      SB=SIN(RAD*XPP(K,5))
      GB=CG*CA-CB
      IF(LA.EQ.3) GO TO 11
      CA=COS(RAD*XPP(K,4))
      SA=SIN(RAD*XPP(K,4))
      GA=CB*CG-CA
   11 DO 12 I=1,IREF
      IF(IMC(I).NE.K) GO TO 12
      SH=FLOAT(IDX(I,1))/AA
      SK=FLOAT(IDX(I,2))/BB
      SL=FLOAT(IDX(I,3))/CC
      DS=SH*SH*SA*SA+SK*SK*SB*SB+SL*SL*SG*SG
     1  +2.0*(SK*SL*GA+SL*SH*GB+SH*SK*GG)
      DS=DS/(1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG)
      DSR(I)=SQRT(DS)
   12 CONTINUE
C
C     Rearrangement of reflections
C
      DO 24 I=1,IREF
   21 II=IMC(I)
      IM=NGM(I)
      DS=DSR(I)
      XR=RIN(I,1)
      IH=IDX(I,1)
      IK=IDX(I,2)
      IL=IDX(I,3)
      IX=I
      DO 22 J=I+1,IREF
      IF(DSR(J).LT.DS) IX=J
   22 CONTINUE
      IF(IX.LE.I) GO TO 24
      DO 23 J=I,IX-1
      IMC(J)=IMC(J+1)
      NGM(J)=NGM(J+1)
      DSR(J)=DSR(J+1)
      RIN(J,1)=RIN(J+1,1)
      IDX(J,1)=IDX(J+1,1)
      IDX(J,2)=IDX(J+1,2)
   23 IDX(J,3)=IDX(J+1,3)
      IMC(IX)=II
      NGM(IX)=IM
      DSR(IX)=DS
      RIN(IX,1)=XR
      IDX(IX,1)=IH
      IDX(IX,2)=IK
      IDX(IX,3)=IL
      GO TO 21
   24 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE GROUP
C     Grouping of reflections in a definit width of 2-theta angle.
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/
C
      N=1
      MLT(1)=1
      JRF(1)=1
      DO 11 I=2,IREF
      D=ABS(DSR(I)-DSR(I-1))
      IF(D.GE.0.00001) THEN
        N=N+1
        MLT(N)=1
        JRF(N)=I
        ELSE
        MLT(N)=MLT(N)+1
      END IF
   11 CONTINUE
      NREF=N
C
      DO 22 I=1,NREF
      J=JRF(I)
      DS=DSR(J)
      S1=0.5*WVL1*DS
      C1=SQRT(1.0-S1*S1)
      TN=S1/C1
      TC=XBG(9)+XBG(10)*TN+XBG(11)*TN*TN
      T1=2.0*DEG*ASIN(S1)+TC
      IF(NSOD.GT.1) THEN
        S2=0.5*WVL2*DS
        ET=2.0*DEG*XBG(8)*TAN(0.5*RAD*T1)/WVL1
        T2=2.0*DEG*ASIN(S2)+TC+ET
        ELSE
        ET=0.0
        T2=0.0
      END IF
      TTH(I,1)=T1
      TTH(I,2)=T2
      TTH(I,3)=TC+ET
C
      M=MLT(I)
      R=RIN(J,1)
      IF(M.GT.1) THEN
        DO 21 K=2,M
   21   R=R+RIN(J+K-1,1)
      END IF
      XRP(I)=R
   22 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE SELECT (NC,NRED,NVAR,NXRP,NONL,NSET,GRUP)
      COMMON/PSEL/IRP(500),IBG(11),IPP(5,19)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
C
  211 FORMAT(//' Parameter selection in the least-squares cycle of',I3)
  212 FORMAT(//' For global parameters, input the following integers:'
     . //5X,'0: to fix parameter,   1: to vary parameter.')
  213 FORMAT(/5X,'For b1, b2, ..b6.')
  214 FORMAT( 5X,'For K and e.')
  215 FORMAT( 5X,'For t1, t2, t3.')
  216 FORMAT(//' For intensity parameters, Ij, of',I2,'th component,'
     .  /5X,'input the following integers.'
     . //5X,'0: to fix all Ij"s,   1: to vary all Ij"s.')
  221 FORMAT(/' For profile parameters of',I2,'th component,'
     .  /5X,'input the following integers.'
     . //5X,'0: to fix parameter,   1: to vary parameter,'
     .  /5X,'N: to reset parameter X as'
     .  /8X,'X of',I2,'th component = X of N-1th component,'
     .  /5X,'9: to reset rHj as rHj = rLj.')
  222 FORMAT(/5X,'For a,b,c, ..')
  223 FORMAT( 5X,'For w1, w2, w3.')
  224 FORMAT( 5X,'For a1, a2, a3.')
  225 FORMAT( 5X,'For rL1, rL2, rL3.')
  226 FORMAT( 5X,'For rH1, rH1, rH2.')
  227 FORMAT( 5X,'For scale.')
  228 FORMAT(//5X,'Select once more after reading carefully !')
  229 FORMAT(/' How many cycles do you repeat this parameter selection?'
     .//5X,'Nr = -1: back to the beginning of selection,'
     . /5X,'Nr =  0: to the parameter convergence,'
     . /5X,'Nr >  0: in n cycles (maximum Nc = 25),'
     . /5X,'Nr = 99: terminate after this cycle.')
  251 FORMAT(/4X,'Parameter selections in cycle',I3/4X,'Nr =',I3
     .  /3X,'IRP = ',21I3,9(/3X,23I3))
  252 FORMAT(3X,'IBG = ',11I3,5(/3X,'IPP = ',19I3))
C
   11 NCHK=0
      DO 12 I=1,NREF
      IF(XRP(I).GT.0.0) NCHK=1
   12 IRP(I)=0
      DO 13 I=1,11
   13 IBG(I)=0
      DO 14 K=1,NCOM
      DO 14 I=1,19
   14 IPP(K,I)=0
C
      WRITE(*,211) NC
      WRITE(*,212)
      WRITE(*,213)
      READ(*,*) (IBG(I),I=1,6)
      IF(NCHK.NE.0) THEN
      IF(NSOD.EQ.2) THEN
        WRITE(*,214)
        READ(*,*) IBG(7),IBG(8)
      END IF
        WRITE(*,215)
        READ(*,*) (IBG(I),I=9,11)
      END IF
C
      DO 24 K=1,NCOM
      WRITE(*,216) K
      READ(*,*) N
      IF(N.NE.0) THEN
        DO 21 I=1,NREF
        J=JRF(I)
        IF(IMC(J).EQ.K) IRP(I)=1
   21   CONTINUE
      END IF
      IF(N.EQ.0) THEN
        IPP(K,19)=1
        ELSE
        IPP(K,19)=0
      END IF
C
      IF(NCHK.NE.0) THEN
   22 WRITE(*,221) K,K
      WRITE(*,222)
      READ(*,*) IPP(K,1)
      WRITE(*,223)
      READ(*,*) (IPP(K,I),I=7,9)
      WRITE(*,224)
      READ(*,*) (IPP(K,I),I=10,12)
      WRITE(*,225)
      READ(*,*) (IPP(K,I),I=13,15)
      WRITE(*,226)
      READ(*,*) (IPP(K,I),I=16,18)
      IF(IPP(K,19).NE.0) THEN
        WRITE(*,227)
        READ(*,*) IPP(K,19)
      END IF
      DO 23 I=1,19
      IF(IPP(K,I).LE.K.OR.IPP(K,I).EQ.9) GO TO 23
      WRITE(*,228)
      GO TO 22
   23 CONTINUE
      END IF
   24 CONTINUE
C
      WRITE(*,229)
      READ(*,*) NRED
      IF(NRED.LT.0) GO TO 11
C
C     The position in the normal matrix is assigned to each parameter
C     tan(15 degree) = 0.267949192
C
      TA=0.267949192E0
      WI=GRUP/SQRT(XPP(1,7)+XPP(1,8)*TA+XPP(1,9)*TA*TA)
      DO 31 I=2,NREF
      IF(NSET.GT.1) THEN
        TN=TAN(0.008726646*TTH(I,1))
        WD=WI*SQRT(XPP(1,7)+XPP(1,8)*TN+XPP(1,9)*TN*TN)
        ELSE
        WD=GRUP
      END IF
      D=ABS(TTH(I,1)-TTH(I-1,1))
      IF(IRP(I).NE.0.AND.IRP(I-1).NE.0.AND.D.LT.WD) IRP(I)=2
   31 CONTINUE
C
      DO 32 K=1,NCOM
      IF(IPP(K,1).EQ.0) GO TO 32
      LA=LAUE(K)
      IPP(K,1)=1
      IPP(K,2)=1
      IF(LA.GT.4) IPP(K,2)=9
      IPP(K,3)=1
      IF(LA.GT.6.AND.LA.LT.11) IPP(K,3)=9
      IPP(K,4)=0
      IF(LA.EQ.1.OR.LA.EQ.9.OR.LA.EQ.10) IPP(K,4)=1
      IPP(K,5)=0
      IF(LA.EQ.1.OR.LA.EQ.3)  IPP(K,5)=1
      IF(LA.EQ.9.OR.LA.EQ.10) IPP(K,5)=9
      IPP(K,6)=0
      IF(LA.EQ.1.OR.LA.EQ.2)  IPP(K,6)=1
      IF(LA.EQ.9.OR.LA.EQ.10) IPP(K,6)=9
   32 CONTINUE
C
      N=0
      DO 43 I=1,NREF
      M=IRP(I)
      IF(M-1) 43,41,42
   41 N=N+1
      IRP(I)=N
      GO TO 43
   42 IRP(I)=IRP(I-1)
   43 CONTINUE
      NXRP=N
      DO 46 I=1,11
      M=IBG(I)
      IF(M) 45,45,44
   44 N=N+1
      IBG(I)=N
   45 IF(I.EQ.6) NONL=N
   46 CONTINUE
C
      DO 55 K=1,NCOM
      DO 55 I=1,19
      M=IPP(K,I)
      IF(M-1) 55,51,52
   51 N=N+1
      IPP(K,I)=N
      GO TO 55
   52 IF(M.EQ.9) GO TO 53
      IPP(K,I)=IPP(K-1,I)
      GO TO 55
   53 IF(I.GT.6) GO TO 54
      IPP(K,I)=IPP(K,I-1)
      GO TO 55
   54 IPP(K,I)=IPP(K,I-3)
   55 CONTINUE
C
      NVAR=N
      IF(NVAR.EQ.NONL) THEN
        NONL=0
        ELSE
        NONL=1
      END IF
      WRITE(*,251) NC,NRED,(IRP(I),I=1,NREF)
      WRITE(*,252) (IBG(I),I=1,11),((IPP(K,I),I=1,19),K=1,NCOM)
      RETURN
      END
C
C
C
      SUBROUTINE REFLEX (LCYL,NONL,DRPF,STEP)
      COMMON/CONS/FWH(500),DRA(500,2),DDA(500,6),DAG(500,7,2),
     .            IDR(500,2,2),ASM(500)
      COMMON/PSEL/IRP(500),IBG(11),IPP(5,19)
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      DATA RAD,DEG,PAI/0.01745329252E0,57.29577951E0,3.141592654E0/
C
      RA1=1.0/(1.0+XBG(7))
      RA2=XBG(7)*RA1
      DO 54 K=1,NCOM
      SC=XPP(K,19)
      LA=LAUE(K)
      AA=XPP(K,1)
      BB=XPP(K,2)
      CC=XPP(K,3)
      IF(LA.GT.3.AND.LA.LT.9.OR.LA.GT.10) GO TO 11
      CA=COS(RAD*XPP(K,4))
      SA=SIN(RAD*XPP(K,4))
      IF(LA.EQ.9.OR.LA.EQ.10) GO TO 11
      CB=COS(RAD*XPP(K,5))
      SB=SIN(RAD*XPP(K,5))
      CG=COS(RAD*XPP(K,6))
      SG=SIN(RAD*XPP(K,6))
      GA=CB*CG-CA
      GB=CG*CA-CB
      GG=CA*CB-CG
C
   11 DO 53 I=1,NREF
      J=JRF(I)
      IF(IMC(J).NE.K) GO TO 53
      DS=DSR(J)
      IF(IPP(K,1).EQ.0.OR.LCYL.GT.0) GO TO 29
      SH=FLOAT(IDX(J,1))/AA
      SK=FLOAT(IDX(J,2))/BB
      SL=FLOAT(IDX(J,3))/CC
      GO TO (21,22,23,24,25,25,26,26,27,27,28,28,28,28,28),LA
C
C     Calculation of derivatives with respect to unit cell paerameters
C
   21 DD=1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG
      D1=(SH*SA)**2+SL*SH*GB+SH*SK*GG
      DDA(I,1)=-DEG*D1/(DS*AA*DD)
      D2=(SK*SB)**2+SK*SL*GA+SH*SK*GG
      DDA(I,2)=-DEG*D2/(DS*BB*DD)
      D3=(SL*SG)**2+SK*SL*GA+SL*SH*GB
      DDA(I,3)=-DEG*D3/(DS*CC*DD)
      D4=DS*DS*GA+SH*SH*CA+SK*SL-SL*SH*CG-SH*SK*CB
      DDA(I,4)=D4*SA/(DS*DD)
      D5=DS*DS*GB+SK*SK*CB-SK*SL*CG+SL*SH-SH*SK*CA
      DDA(I,5)=D5*SB/(DS*DD)
      D6=DS*DS*GG+SL*SL*CG-SK*SL*CB-SL*SH*CA+SH*SK
      DDA(I,6)=D6*SG/(DS*DD)
      GO TO 29
   22 D1=SH*SH-SH*SK*CG
      DDA(I,1)=-DEG*D1/(DS*SG*SG*AA)
      D2=SK*SK-SH*SK*CG
      DDA(I,2)=-DEG*D2/(DS*SG*SG*BB)
      DDA(I,3)=-DEG*SL*SL/(DS*CC)
      D4=(SH*SH+SK*SK)*CG-SH*SK*(CG*CG+1.0)
      DDA(I,4)=-D4/(DS*SG*SG*SG)
      GO TO 29
   23 D1=SH*SH-SL*SH*CB
      DDA(I,1)=-DEG*D1/(DS*SB*SB*AA)
      DDA(I,2)=-DEG*SK*SK/(DS*BB)
      D3=SL*SL-SL*SH*CB
      DDA(I,3)=-DEG*D3/(DS*SB*SB*CC)
      D4=(SH*SH+SL*SL)*CB-SL*SH*(CB*CB+1.0)
      DDA(I,4)=-D4/(DS*SB*SB*SB)
      GO TO 29
   24 DDA(I,1)=-DEG*SH*SH/(DS*AA)
      DDA(I,2)=-DEG*SK*SK/(DS*BB)
      DDA(I,3)=-DEG*SL*SL/(DS*CC)
      GO TO 29
   25 DDA(I,1)=-DEG*(SH*SH+SK*SK)/(DS*AA)
      DDA(I,2)=-DEG*SL*SL/(DS*CC)
      GO TO 29
   26 DDA(I,1)=-DEG*DS/AA
      GO TO 29
   27 DDA(I,1)=-DEG*DS/AA
      D1=(SH*SH+SK*SK+SL*SL)*CA*(2.0+CA)
      D2=(SK*SL+SL*SH+SH*SK)*(1.0+2.0*CA*CA)
      D3=(1.0+CA-2.0*CA*CA)**2
      DDA(I,2)=SA*(-D1+D2)/(DS*D3)
      GO TO 29
   28 DDA(I,1)=-DEG*4.0*(SH*SH+SH*SK+SK*SK)/(3.0*DS*AA)
      DDA(I,2)=-DEG*SL*SL/(DS*CC)
   29 CONTINUE
C
C     Calculation of some constants
C
      ST=0.5*WVL1*DS
      CT=SQRT(1.0-ST*ST)
      TN=ST/CT
      FW=SQRT(XPP(K,7)+XPP(K,8)*TN+XPP(K,9)*TN*TN)
      AS=XPP(K,10)+XPP(K,11)*(1.41421356-1.0/ST)
     1  +XPP(K,12)*(2.0-1.0/(ST*ST))
      RL=XPP(K,13)+XPP(K,14)*ST+XPP(K,15)/ST
      RH=XPP(K,16)+XPP(K,17)*ST+XPP(K,18)/ST
      IF(NFNC.EQ.0.AND.RL.LE.0.51) RL=0.51
      IF(NFNC.EQ.0.AND.RH.LE.0.51) RH=0.51
      FWH(I)=FW
      ASM(I)=AS
      DRA(I,1)=RL
      DRA(I,2)=RH
      RI=SC*XRP(I)
      R1=RI*RA1
      R2=RI*RA2
      T1=TTH(I,1)
      T2=TTH(I,2)
      IF(NFNC-1) 31,41,41
C
C     Pearson VII function
C
   31 CL=1.0/RL
      CH=1.0/RH
      EL=2.0**CL-1.0
      EH=2.0**CH-1.0
      DL=GAMMA(RL-0.5)/(SQRT(EL)*GAMMA(RL))
      DH=GAMMA(RH-0.5)/(SQRT(EH)*GAMMA(RH))
      GH=(1.0+AS)*(1.0+AS)
      GL=GH/(AS*AS)
      QQ=AS*DL+DH
      DAG(I,1,1)=GL*EL
      DAG(I,1,2)=GH*EH
      DAG(I,2,1)=1.128379167E0*(1.0+AS)/(QQ*FW)
      DAG(I,2,2)=DAG(I,2,1)
      IF(NONL.EQ.0.OR.LCYL.GT.0) GO TO 32
      DAG(I,3,1)=2.0*RL*GL*EL/FW
      DAG(I,3,2)=2.0*RH*GH*EH/FW
      DAG(I,4,1)=1.0/(1.0+AS)-DL/QQ
      DAG(I,4,2)=DAG(I,4,1)
      DAG(I,5,1)= 2.0*RL*EL*(1.0+AS)/(AS*AS*AS)
      DAG(I,5,2)=-2.0*RH*EH*(1.0+AS)
      DS=1000.0
      SL=RL+1.0/DS
      SH=RH+1.0/DS
      PL=1.0/SL
      PH=1.0/SH
      FL=2.0**PL-1.0
      FH=2.0**PH-1.0
      BL=GAMMA(SL-0.5)/(SQRT(FL)*GAMMA(SL))
      BH=GAMMA(SH-0.5)/(SQRT(FH)*GAMMA(SH))
      DAG(I,6,1)=-AS*DS*(BL-DL)/QQ
      DAG(I,6,2)=   -DS*(BH-DH)/QQ
      DAG(I,7,1)=ALOG(2.0)*GL*(EL+1.0)/RL
      DAG(I,7,2)=ALOG(2.0)*GH*(EH+1.0)/RH
C
C     Set definition range of Pearson VII
C
   32 P1=DAG(I,2,1)*R1/DRPF
      P2=DAG(I,2,1)*R2/DRPF
      IF(P2.LE.1.0) GO TO 51
      T11=T1-FW*SQRT(P1**CL-1.0)/SQRT(DAG(I,1,1))
      T12=T1+FW*SQRT(P1**CH-1.0)/SQRT(DAG(I,1,2))
      IF(NSOD.EQ.1) GO TO 52
      T21=T2-FW*SQRT(P2**CL-1.0)/SQRT(DAG(I,1,1))
      T22=T2+FW*SQRT(P2**CH-1.0)/SQRT(DAG(I,1,2))
      GO TO 52
C
C     pseudo-Voigt function
C
   41 CL=RL+(1.0-RL)*1.475664627E0
      CH=RH+(1.0-RH)*1.475664627E0
      SS=2.0/(CL+AS*CH)
      SL=CH*SS
      SH=CL*SS
      DH=(1.0+AS)/FW
      DL=DH/AS
      DAG(I,1,1)=DL**2
      DAG(I,1,2)=DH**2
      DAG(I,2,1)=DAG(I,1,1)*0.693147181E0
      DAG(I,2,2)=DAG(I,1,2)*0.693147181E0
      DA=(1.0+AS)/(PAI*FW)
      DAG(I,3,1)=SL*RL*DA
      DAG(I,3,2)=SH*RH*DA
      DB=(1.0+AS)*0.469718639E0/FW
      DAG(I,4,1)=SL*(1.0-RL)*DB
      DAG(I,4,2)=SH*(1.0-RH)*DB
      IF(NONL.EQ.0.OR.LCYL.GT.0) GO TO 42
      DAG(I,5,1)=1.0/(1.0+AS)-0.5*SL
      DAG(I,5,2)=DAG(I,5,1)
      DAG(I,6,1)=0.475664627E0/(CL+AS*CH)
      DAG(I,6,2)=-DAG(I,6,1)*AS*CH/CL
      DAG(I,7,1)=-DAG(I,6,1)*CL/CH
      DAG(I,7,2)= DAG(I,6,1)*AS
C
C     Set definition range of pseudo-Voigt
C
   42 IF(0.5*(RL+RH).LT.0.1) GO TO 51
      P1=DAG(I,3,1)/DRPF
      P2=DAG(I,3,2)/DRPF
      IF(R2*P1.LE.1.0.OR.R2*P2.LE.1.0) GO TO 51
      AW=FW/(1.0+AS)
      T11=T1-AS*AW*SQRT(R1*P1-1.0)
      T12=T1+   AW*SQRT(R1*P2-1.0)
      IF(NSOD.EQ.1) GO TO 52
      T21=T2-AS*AW*SQRT(R2*P1-1.0)
      T22=T2+   AW*SQRT(R2*P2-1.0)
      GO TO 52
C
   51 SW=4.0*FW/(1.0+AS)
      T11=T1-SW*AS
      T12=T1+SW
      IF(NSOD.EQ.1) GO TO 52
      T21=T2-SW*AS
      T22=T2+SW
   52 IF(T11.LT.TTHA) T11=TTHA
      IF(T12.GT.TTHB) T12=TTHB
      IDR(I,1,1)=(T11-TTHA+0.0001)/STEP+1.0
      IDR(I,1,2)=(T12-TTHA+0.0001)/STEP+1.0
      IF(NSOD.EQ.1) GO TO 53
      IF(T21.LT.TTHA) T21=TTHA
      IF(T22.GT.TTHB) T22=TTHB
      IDR(I,2,1)=(T21-TTHA+0.0001)/STEP+1.0
      IDR(I,2,2)=(T22-TTHA+0.0001)/STEP+1.0
   53 CONTINUE
   54 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE YCALC (NMM1,NMM2,LREF,LCYL,NVAR,NONL,N,YO,YC,YB,DER)
      COMMON/CONS/FWH(500),DRA(500,2),DDA(500,6),DAG(500,7,2),
     .            IDR(500,2,2),ASM(500)
      COMMON/PSEL/IRP(500),IBG(11),IPP(5,19)
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/YOBS/NFBG,RTT(10001),YOB(10001),YCL(10001)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      DIMENSION DER(550),NCP(15)
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/
      DATA NCP/6,4,4,3,2,2,1,1,2,2,2,2,2,2,2/
      DRTX=5.0
C
      NMM1=0
      NMM2=0
      YO=YOB(N)
      IF(YO.LE.0.0) THEN
        YCL(N)=0.0
        GO TO 99
      END IF
      TK=RTT(N)
      RB=XBG(7)
      RA=1.0/(1.0+RB)
C
C     Calculation of background intensity and its derivatives
C
      IF(NFBG.NE.0) GO TO 11
      ST=SIN(0.5*RAD*TK)
      TN=TAN(0.5*RAD*TK)
      YB=XBG(1)+XBG(2)*TK+XBG(3)*ST+XBG(4)*TN
      IF(LCYL.GT.0) GO TO 21
      IF(IBG(1).NE.0) DER(IBG(1))=1.0
      IF(IBG(2).NE.0) DER(IBG(2))=TK
      IF(IBG(3).NE.0) DER(IBG(3))=ST
      IF(IBG(4).NE.0) DER(IBG(4))=TN
      GO TO 21
C
   11 BP1=2.0/(TTHB-TTHA)
      BP2=(TTHA+TTHB)/(TTHB-TTHA)
      T1=BP1*TK-BP2
      T2=T1*T1
      T3=T2*T1
      T4=T2*T2
      T5=T3*T2
      YB=XBG(1)+XBG(2)*T1+XBG(3)*T2+XBG(4)*T3+XBG(5)*T4+XBG(6)*T5
      IF(LCYL.GT.0) GO TO 21
      IF(IBG(1).NE.0) DER(IBG(1))=1.0
      IF(IBG(2).NE.0) DER(IBG(2))=T1
      IF(IBG(3).NE.0) DER(IBG(3))=T2
      IF(IBG(4).NE.0) DER(IBG(4))=T3
      IF(IBG(5).NE.0) DER(IBG(5))=T4
      IF(IBG(6).NE.0) DER(IBG(6))=T5
C
C     Calculation of peak profile intensity
C
   21 YP=0.0
      DO 93 I=LREF,NREF
      IF(TTH(I,1)+DRTX.LT.TK) GO TO 92
      IF(TTH(I,1)-DRTX.GT.TK) GO TO 94
      JI=JRF(I)
      II=IMC(JI)
      SC=XPP(II,19)
      RI=SC*XRP(I)
      FW=FWH(I)
      AS=ASM(I)
      RL=DRA(I,1)
      RH=DRA(I,2)
      ST=SIN(0.5*RAD*TTH(I,1))
      TN=ST/SQRT(1.0-ST*ST)
      DO 91 J=1,NSOD
      IF(N.LT.IDR(I,J,1).OR.N.GT.IDR(I,J,2)) GO TO 91
      TT=TTH(I,J)
      YE=RI*RA
      IF(J.EQ.2) YE=YE*RB
      DK=TK-TT
      K=1
      IF(DK.GT.0.0) K=2
      IF(NFNC-1) 22,23,23
C
C     Pearson VII function
C
   22 DK=DK/FW
      DD=DK*DK
      FF=1.0+DAG(I,1,K)*DD
      RX=DRA(I,K)
      DF=FF**RX
      DF=DAG(I,2,K)/DF
      YF=YE*DF
      GO TO 24
C
C     pseudo-Voigt function
C
   23 DD=DK*DK
      FL=1.0+DAG(I,1,K)*DD
      FG=DAG(I,2,K)*DD
      PL=DAG(I,3,K)/FL
      IF(FG.LE.15.0) THEN
        PG=DAG(I,4,K)*EXP(-FG)
        ELSE
        PG=0.0
      END IF
      YL=YE*PL
      YG=YE*PG
      YF=YL+YG
C
   24 YP=YP+YF
      IF(LCYL-1) 31,91,91
C
C     Calculation of derivatives with respect to profile parameters
C
   31 IF(NONL.EQ.0) GO TO 81
      DO 39 L=7,11
      M=IBG(L)
      IF(M.EQ.0) GO TO 39
      LL=L-6
      GO TO (32,33,34,35,36) LL
   32 DX=-YF*RA
      IF(J.EQ.2) DX=-DX/RB
      GO TO 38
   33 IF(J.EQ.1) GO TO 38
      IF(NFNC.EQ.0) DX=YF*DAG(I,3,K)*DK/FF
      IF(NFNC.NE.0) DX=(YL/FL+YG*0.693147181E0)*2.0*DAG(I,1,K)*DK
      DX=DX*2.0*DEG*TAN(0.5*RAD*TT)/WVL1
      GO TO 38
   34 CX=1.0
      GO TO 37
   35 CX=TN
      GO TO 37
   36 CX=TN*TN
   37 IF(NFNC.EQ.0) DX=CX*YF*DAG(I,3,K)*DK/FF
      IF(NFNC.NE.0) DX=CX*(YL/FL+YG*0.693147181E0)*2.0*DAG(I,1,K)*DK
   38 DER(M)=DER(M)+DX
   39 CONTINUE
C
      M=IPP(II,1)
      IF(M.EQ.0) GO TO 51
      LA=LAUE(II)
      NUCP=NCP(LA)
      IF(J.EQ.1) THEN
        CK=WVL1/COS(0.5*RAD*TTH(I,1))
        ELSE
        CK=WVL2/COS(0.5*RAD*TTH(I,2))
      END IF
      IF(NFNC.EQ.0) DX=YF*DAG(I,3,K)*DK/FF
      IF(NFNC.NE.0) DX=(YL/FL+YG*0.693147181E0)*2.0*DAG(I,1,K)*DK
      DX=DX*CK
      DO 41 L=1,NUCP
      LL=M+L-1
   41 DER(LL)=DER(LL)+DX*DDA(I,L)
C
   51 DO 79 L=7,19
      M=IPP(II,L)
      IF(M) 79,79,52
   52 LL=L-6
      GO TO (53,54,55,61,62,63,66,67,68,71,72,73,76),LL
C
   53 CX=0.5/FW
      GO TO 56
   54 CX=0.5*TN/FW
      GO TO 56
   55 CX=0.5*TN*TN/FW
   56 IF(NFNC.EQ.0) THEN
        DX=YF*(DAG(I,3,K)*DD/FF-1.0/FW)
        ELSE
        DX=(YL*(1.0-2.0/FL)+YG*(2.0*FG-1.0))/FW
      END IF
      GO TO 78
C
   61 CX=1.0
      GO TO 64
   62 CX=1.41421356-1.0/ST
      GO TO 64
   63 CX=2.0-1.0/(ST*ST)
   64 IF(NFNC.EQ.0) THEN
        DX=YF*(DAG(I,4,K)+DAG(I,5,K)*DD/FF)
        ELSE
        DX=-2.0*(YL*(1.0-1.0/FL)+YG*FG)/(1.0+AS)
        IF(K.EQ.1) DX=-DX/AS
        DX=DX+YF*DAG(I,5,K)
      END IF
      GO TO 78
C
   66 CX=1.0
      GO TO 69
   67 CX=ST
      GO TO 69
   68 CX=1.0/ST
   69 IF(NFNC.EQ.0) THEN
        DX=YF*DAG(I,6,1)
        IF(K.EQ.1) DX=DX+YF*(-ALOG(FF)+DAG(I,7,K)*DD/FF)
        ELSE
        DX=YF*DAG(I,6,K)
        IF(K.EQ.1.AND.RL.NE.0.0) DX=DX+YL/RL
        IF(K.EQ.1.AND.RL.NE.1.0) DX=DX-YG/(1.0-RL)
      END IF
      GO TO 78
C
   71 CX=1.0
      GO TO 74
   72 CX=ST
      GO TO 74
   73 CX=1.0/ST
   74 IF(NFNC.EQ.0) THEN
        DX=YF*DAG(I,6,2)
        IF(K.EQ.2) DX=DX+YF*(-ALOG(FF)+DAG(I,7,K)*DD/FF)
        ELSE
        DX=YF*DAG(I,7,K)
        IF(K.EQ.2.AND.RH.NE.0.0) DX=DX+YL/RH
        IF(K.EQ.2.AND.RH.NE.1.0) DX=DX-YG/(1.0-RH)
      END IF
      GO TO 78
C
   76 DX=YF
      CX=1.0/SC
C
   78 DER(M)=DER(M)+CX*DX
   79 CONTINUE
C
C     Calculation of derivatives with respect to integratd intensity
C
   81 M=IRP(I)
      IF(M) 91,91,82
   82 IF(NMM1.EQ.0) NMM1=M
      NMM2=M
      IF(NFNC.EQ.0) DX=RA*DF
      IF(NFNC.NE.0) DX=RA*(PL+PG)
      IF(J.EQ.2) DX=DX*RB
      DER(M)=DER(M)+DX
C
   91 CONTINUE
      GO TO 93
   92 LREF=LREF+1
   93 CONTINUE
   94 YC=YB+YP
      YCL(N)=YC
   99 RETURN
      END
C
C
C
      SUBROUTINE MATRIX (NC,LCYL,NCHA,NOBS,NVAR,NXRP,NONL)
C     Subroutine for calculating normal matrix and matrix inversuion
C     Two two-dimensional arrays, ALL and AMM, are used to store
C        normal matrix elements
C     Modified Choleski method is used for matrix inversin
C
      DOUBLE PRECISION ALL,AMM,VVV,WA,WB,WC,WE,DIG
      COMMON/CHNG/NRES,RMIN,PRWP,XVA(550),DIA(550)
      DIMENSION ALL(500,5),AMM(50,550),VVV(550),DIG(550)
      DIMENSION DER(550)
C
  211 FORMAT(/5X,'After  cycle',I3,': Rp =',F8.5,
     .    ',  Rwp =',F8.5,',  Rp(peak) =',F8.5,'.')
  212 FORMAT(/5X,'Before cycle',I3,': Rp =',F8.5,
     .    ',  Rwp =',F8.5,',  Rp(peak) =',F8.5,'.')
  221 FORMAT(/5X,'Matrix is singular for ii =',I3)
C
      NALL=NXRP
      NAMM=NVAR-NXRP
      NAKK=5
      LREF=1
      C1=0.0
      C2=0.0
      D1=0.0
      D2=0.0
      IF(LCYL.EQ.0) THEN
        DO 11 I=1,NVAR
   11   VVV(I)=0.0D0
        IF(NALL.GT.0) THEN
          DO 12 I=1,NALL
          DO 12 J=1,NAKK
   12     ALL(I,J)=0.0D0
        END IF
        IF(NAMM.GT.0) THEN
          DO 13 I=1,NAMM
          DO 13 J=1,NVAR
   13     AMM(I,J)=0.0D0
        END IF
      END IF
C
      DO 29 N=1,NOBS
      DO 21 I=1,NVAR
   21 DER(I)=0.0
C
      CALL YCALC (NMM1,NMM2,LREF,LCYL,NVAR,NONL,N,YO,YC,YB,DER)
C
      IF(YO) 29,29,22
   22 WG=1.0/YO
      DY=YO-YC
      C1=C1+ABS(DY)
      C2=C2+WG*DY*DY
      D1=D1+YO
      E1=YO-YB
      IF(E1.LT.0.0) E1=0.0
      D2=D2+E1
      IF(LCYL.GT.0) GO TO 29
      IF(NMM2.EQ.0) GO TO 25
      DO 24 I=NMM1,NMM2
      DE=WG*DER(I)
      WE=DE*DY
      VVV(I)=VVV(I)+WE
      L=I-NMM1+1
      IF(L.GT.NAKK) L=NAKK
      DO 23 J=1,L
      K=I-J+1
      WE=DE*DER(K)
   23 ALL(I,J)=ALL(I,J)+WE
   24 CONTINUE
   25 IF(NAMM.EQ.0) GO TO 29
      DO 28 I=1,NAMM
      L=I+NALL
      DE=WG*DER(L)
      WE=DE*DY
      VVV(L)=VVV(L)+WE
      DO 26 J=1,I
      K=L-J+1
      WE=DE*DER(K)
   26 AMM(I,J)=AMM(I,J)+WE
      IF(NMM2.EQ.0) GO TO 28
      DO 27 J=NMM1,NMM2
      K=L-J+1
      WE=DE*DER(J)
   27 AMM(I,K)=AMM(I,K)+WE
   28 CONTINUE
   29 CONTINUE
C
      R1=C1/D1
      R2=SQRT(C2/D1)
      IF(D2.NE.0.0) THEN
        R3=C1/D2
      ELSE
        R3=0.0
      END IF
      RN=NOBS-NVAR
      SVAR=SQRT(C2/RN)
      PRWP=R2
      IF(NC.EQ.1) RMIN=R2
      IF(R2.LE.RMIN) THEN
        RMIN=R2
        NRES=NC
      END IF
C
      IF(LCYL.GT.0) THEN
        LCYL=2
        MC=NC-1
        WRITE(*,211)  MC,R1,R2,R3
        WRITE(21,211) MC,R1,R2,R3
        GO TO 99
      ELSE
        WRITE(*,212)  NC,R1,R2,R3
        WRITE(21,212) NC,R1,R2,R3
        IF(R2.GT.0.1.AND.R2-RMIN.GT.0.100) GO TO 97
        IF(R2.LE.0.1.AND.R2-RMIN.GT.0.050) GO TO 97
      END IF
C
C     Checking singular matrix
C
      IZ=0
      DO 31 I=1,NVAR
      K=I-NALL
      IF(K.LE.0.AND.ALL(I,1).GT.0.0) GO TO 31
      IF(K.GT.0.AND.AMM(K,1).GT.0.0) GO TO 31
      IZ=IZ+1
      WRITE(*,221)  I
      WRITE(21,221) I
   31 CONTINUE
      IF(IZ.GT.0) GO TO 98
C
      IF(NVAR.EQ.1) THEN
        IF(NALL.EQ.1) THEN
          DIA(1)=1.0D0/DSQRT(ALL(1,1))
          XVA(1)=VVV(1)/ALL(1,1)
        END IF
        IF(NAMM.EQ.1) THEN
          DIA(1)=1.0D0/DSQRT(AMM(1,1))
          XVA(1)=VVV(1)/AMM(1,1)
        END IF
        DIA(1)=SVAR*DIA(1)
        GO TO 99
      END IF
C
      DO 67 I=2,NVAR
      IF(I.GT.NALL) GO TO 61
      KA=NAKK-1
      IF(I.LT.NAKK) KA=I-1
      WA=0.0D0
      DO 51 K=1,KA
      DIG(K)=ALL(I,K+1)/ALL(I-K,1)
   51 WA=WA+DIG(K)*VVV(I-K)
      VVV(I)=VVV(I)-WA
      KB=NAKK-1
      IF(NALL-I.LT.NAKK-2) KB=NALL-I+1
      DO 53 J=1,KB
      L=I+J-1
      WA=0.0D0
      KC=NAKK-J
      IF(I.LT.NAKK.AND.J.LE.NAKK-I) KC=I-1
      DO 52 K=1,KC
   52 WA=WA+DIG(K)*ALL(L,K+J)
      ALL(L,J)=ALL(L,J)-WA
   53 CONTINUE
      IF(NAMM.EQ.0) GO TO 67
      DO 55 J=1,NAMM
      WA=0.0D0
      L=NALL-I+J+1
      DO 54 K=1,KA
   54 WA=WA+DIG(K)*AMM(J,L+K)
      AMM(J,L)=AMM(J,L)-WA
   55 CONTINUE
      GO TO 67
C
   61 WA=0.0D0
      L=I-NALL
      DO 64 K=1,I-1
      IF(K.GE.L) GO TO 62
      WB=AMM(L-K,1)
      GO TO 63
   62 WB=ALL(I-K,1)
   63 DIG(K)=AMM(L,K+1)/WB
   64 WA=WA+DIG(K)*VVV(I-K)
      VVV(I)=VVV(I)-WA
      DO 66 J=L,NAMM
      M=J-L+1
      WA=0.0D0
      DO 65 K=1,I-1
   65 WA=WA+DIG(K)*AMM(J,M+K)
      AMM(J,M)=AMM(J,M)-WA
   66 CONTINUE
   67 CONTINUE
C
      IF(NAMM.EQ.0) GO TO 71
      VVV(NVAR)=VVV(NVAR)/AMM(NAMM,1)
      GO TO 72
   71 VVV(NVAR)=VVV(NVAR)/ALL(NALL,1)
   72 XVA(NVAR)=VVV(NVAR)
      DO 79 K=2,NVAR
      IF(K.GT.NAMM) GO TO 74
      I=NAMM-K+1
      WA=0.0D0
      DO 73 J=I+1,NAMM
   73 WA=WA+AMM(J,J-I+1)*VVV(NALL+J)
      VVV(NALL+I)=(VVV(NALL+I)-WA)/AMM(I,1)
      XVA(NALL+I)=VVV(NALL+I)
      GO TO 79
   74 I=NVAR-K+1
      WA=0.0D0
      IF(K-NAMM.EQ.1) GO TO 76
      L=NAKK-1
      IF(K-NAMM.LT.NAKK) L=K-NAMM-1
      DO 75 J=1,L
   75 WA=WA+ALL(I+J,J+1)*VVV(I+J)
   76 IF(NAMM.EQ.0) GO TO 78
      DO 77 J=1,NAMM
   77 WA=WA+AMM(J,NALL-I+J+1)*VVV(NALL+J)
   78 VVV(I)=(VVV(I)-WA)/ALL(I,1)
      XVA(I)=VVV(I)
   79 CONTINUE
C
      DO 89 I=1,NVAR
      IF(I.GT.NALL) GO TO 81
      DIG(1)=1.0D0/ALL(I,1)
      GO TO 82
   81 DIG(1)=1.0D0/AMM(I-NALL,1)
   82 WB=DIG(1)
      IF(I.EQ.NVAR) GO TO 88
      DO 87 J=I+1,NVAR
      WA=0.0D0
      IF(J.GT.NALL) GO TO 84
      L=NAKK-1
      IF(J-I.LT.NAKK-1) L=J-I
      WC=ALL(J,1)
      DO 83 K=1,L
   83 WA=WA+DIG(K)*ALL(J,L-K+2)
      GO TO 86
   84 L=J-I
      WC=AMM(J-NALL,1)
      DO 85 K=1,L
   85 WA=WA+DIG(K)*AMM(J-NALL,L-K+2)
   86 DIG(J-I+1)=-WA/WC
      WB=WB+WA*WA/WC
   87 CONTINUE
   88 DIA(I)=DSQRT(WB)
      DIA(I)=SVAR*DIA(I)
   89 CONTINUE
      GO TO 99
C
   97 LCYL=-1
      GO TO 99
   98 LCYL=-2
   99 RETURN
      END
C
C
C
      SUBROUTINE CHANGE (NC,LCYL,NVAR,NCHA,NRED)
      CHARACTER HPC*3
      COMMON/PSEL/IRP(500),IBG(11),IPP(5,19)
      COMMON/CHNG/NRES,RMIN,PRWP,XVA(550),DIA(550)
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      COMMON/DUMP/DMP(2)
      DIMENSION ICL(2),IMF(2,500),ABG(2,11),APP(2,5,19),ARP(2,500),
     .     HPC(30)
      DATA HPC/   ' b1',' b2',' b3',' b4',' b5',' b6','  K','  e',' t1',
     .' t2',' t3','  a','  b','  c','alp','bet','gam',' w1',' w2',' w3',
     .' a1',' a2',' a3','rL1','rL2','rL3','rH1','rH2','rH3','Scl'/
C
  211 FORMAT(/2X,'Parameter changes in cycle',I3
     . /5X,'No  Para',11X,'Old',6X,'Change',9X,'New',6X,'e.s.d.')
  212 FORMAT(5X,3X,A3,4X,4F12.6)
  213 FORMAT(5X,I2,1X,A3,4X,4F12.6)
  214 FORMAT(5X,'I',I5,4X,4F12.6)
  221 FORMAT(/2X,'All parameters converge (change < 5% of e.s.d.) in the
     . cycle of',I3,'.')
  222 FORMAT(/2X,'Rwp factor dose not change in the cycle of',I3,'.')
  223 FORMAT(/2X,'L.S. exceeds a preset number of cycles (25).')
  224 FORMAT(/2X,'L.S. was terminated by the user in the cycle of',
     . I3,'.')
  225 FORMAT(//' Do you terminate the least-squares cycle ?')
  231 FORMAT(///' Parameters in this cycle is not of the least Rwp.'
     . /' Parameters in cycle',I3,' (Rwp=',F8.5,') have been reserved.'
     . /' Do you replace present parameters with them ?')
  241 FORMAT(/' !!! Parameters diverge.')
  242 FORMAT(/' !!! Singular matrix.')
  243 FORMAT(//' Select:'
     . //5X,'0: continue with reserved parameters in the least Rwp,'
     .  /5X,'1: continue without changing the parameters,'
     .  /5X,'2: terminate the job.')
C
      IF(LCYL.LT.0)  GO TO 61
      IF(NRES.NE.NC) GO TO 14
      DO 11 I=1,11
      ABG(1,I)=XBG(I)
   11 ABG(2,I)=SBG(I)
      DO 12 I=1,NCOM
      DO 12 J=1,19
      APP(1,I,J)=XPP(I,J)
   12 APP(2,I,J)=SPP(I,J)
      DO 13 I=1,NREF
      IMF(1,I)=JRF(I)
      IMF(2,I)=MLT(I)
      ARP(1,I)=XRP(I)
   13 ARP(2,I)=SRP(I)
C
C     ICON=1: parameters convergence, ICON=2: Rwp does not change.
C     LCYL=1 is a sign for a last cycle of the least-squares
C
   14 ICON=1
      DO 15 I=1,NVAR
      IF(ABS(XVA(I)).GT.0.05*DIA(I)) ICON=0
   15 CONTINUE
      IF(ICON.EQ.1) GO TO 16
      IF(NC.EQ.1) ICL(1)=0
      IMR2=10000.0*PRWP
      IMIN=10000.0*RMIN
      IF(PRWP-AINT(PRWP).GE.0.5) IMR2=IMR2+1
      IF(RMIN-AINT(RMIN).GE.0.5) IMIN=IMIN+1
      IF(IMIN.NE.ICL(2)) ICL(1)=0
      IF(IMR2.EQ.  IMIN) ICL(1)=ICL(1)+1
      IF(ICL(1).EQ.3) ICON=2
      ICL(2)=IMIN
      IF(NC  .GE.25) ICON=3
      IF(NRED.GE.99) ICON=4
   16 IF(ICON.GT. 0) LCYL=1
      IF(LCYL.EQ. 1) NRED=0
C
   21 WRITE(*,211) NC
      IF(NCHA.NE.0) WRITE(21,211) NC
      LD=1
      DO 24 I=1,11
      IF(I.GT.6) LD=2
      M=IBG(I)
      IF(M) 23,23,22
   22 PO=XBG(I)
      PC=XVA(M)
      PN=PO+PC*DMP(LD)
      PS=DIA(M)
      XBG(I)=PN
      SBG(I)=PS
      WRITE(*,212) HPC(I),PO,PC,PN,PS
      IF(NCHA.EQ.1) WRITE(21,212) HPC(I),PO,PC,PN,PS
      IF(NCHA.EQ.2.AND.PC.GT.PS) WRITE(21,212) HPC(I),PO,PC,PN,PS
      GO TO 24
   23 SBG(I)=0.0
   24 CONTINUE
C
      DO 34 I=1,NCOM
      DO 33 J=1,19
      M=IPP(I,J)
      IF(M) 32,32,31
   31 PO=XPP(I,J)
      PC=XVA(M)
      PN=PO+PC*DMP(2)
      IF(J.EQ.19) PN=PO+PC*DMP(1)
      PS=DIA(M)
      XPP(I,J)=PN
      SPP(I,J)=PS
      WRITE(*,213) I,HPC(J+11),PO,PC,PN,PS
      IF(NCHA.EQ.1) WRITE(21,213) I,HPC(J+11),PO,PC,PN,PS
      IF(NCHA.EQ.2.AND.PC.GT.PS) WRITE(21,213) I,HPC(J+11),PO,PC,PN,PS
      GO TO 33
   32 SPP(I,J)=0.0
   33 CONTINUE
   34 CONTINUE
C
      DO 43 I=1,NREF
      M=IRP(I)
      IF(M) 42,42,41
   41 PO=XRP(I)
      PC=XVA(M)
      PN=PO+PC*DMP(1)
      PS=DIA(M)
      XRP(I)=PN
      SRP(I)=PS
      WRITE(*,214) I,PO,PC,PN,PS
      IF(NCHA.EQ.1) WRITE(21,214) I,PO,PC,PN,PS
      IF(NCHA.EQ.2.AND.PC.GT.PS) WRITE(21,214) I,PO,PC,PN,PS
      GO TO 43
   42 SRP(I)=0.0
   43 CONTINUE
C
      IF(LCYL.EQ.0) GO TO 99
      IF(ICON.EQ.1) WRITE(*,221) NC
      IF(ICON.EQ.2) WRITE(*,222) NC
      IF(ICON.EQ.3) WRITE(*,223)
      IF(ICON.EQ.4) WRITE(*,224) NC
      WRITE(*,225)
      READ(*,*) ND
      IF(ND.EQ.0) GO TO 51
      ICL(1)=0
      LCYL=0
      NRED=1
      GO TO 99
C
   51 IF(ICON.EQ.1) WRITE(21,221) NC
      IF(ICON.EQ.2) WRITE(21,222) NC
      IF(ICON.EQ.3) WRITE(21,223)
      IF(ICON.EQ.4) WRITE(21,224) NC
C
      IF(ICON.EQ.1.OR.NC.EQ.NRES) GO TO 99
      WRITE(*,231) NRES,RMIN
      READ(*,*) ND
      IF(ND.NE.0) GO TO 99
      DO 52 I=1,11
      XBG(I)=ABG(1,I)
   52 SBG(I)=ABG(2,I)
      DO 53 I=1,NCOM
      DO 53 J=1,19
      XPP(I,J)=APP(1,I,J)
   53 SPP(I,J)=APP(2,I,J)
      DO 54 I=1,NREF
      JRF(I)=IMF(1,I)
      MLT(I)=IMF(2,I)
      XRP(I)=ARP(1,I)
   54 SRP(I)=ARP(2,I)
      GO TO 99
C
   61 IF(LCYL.EQ.-1) WRITE(*,241)
      IF(LCYL.EQ.-2) WRITE(*,242)
      IF(LCYL.EQ.-1) WRITE(21,241)
      IF(LCYL.EQ.-2) WRITE(21,242)
      WRITE(*,243)
      READ(*,*) ND
      IF(ND-1) 62,66,99
   62 DO 63 I=1,11
      XBG(I)=ABG(1,I)
   63 SBG(I)=ABG(2,I)
      DO 64 I=1,NCOM
      DO 64 J=1,19
      XPP(I,J)=APP(1,I,J)
   64 SPP(I,J)=APP(2,I,J)
      DO 65 I=1,NREF
      JRF(I)=IMF(1,I)
      MLT(I)=IMF(2,I)
      XRP(I)=ARP(1,I)
   65 SRP(I)=ARP(2,I)
      GO TO 67
   66 RMIN=PRWP
   67 LCYL=0
      NRED=1
C
   99 RETURN
      END
C
C
C
      SUBROUTINE BUNKAI
C     Un-grouping of reflections.
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
C
      DO 11 I=1,NREF
      J=JRF(I)
      M=MLT(I)
      DO 11 K=1,M
      RIN(J+K-1,1)=XRP(I)/FLOAT(M)
   11 RIN(J+K-1,2)=SRP(I)
      RETURN
      END
C
C
C
      SUBROUTINE DISPLY (NOBS)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/YOBS/NFBG,RTT(10001),YOB(10001),YCL(10001)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      DIMENSION XLIM(2),YLIM(2),XTT(500),YTT(500),DEF(10001)
C     NREF: the number of reflections, NOBS: the number of observetions,
C     RTT(i): 2-theta for ith step,  YOB(i): observed profile intensity,
C     YCL(i): calculated profile intensity, YPE(J,i): Ycal for jth peak,
C     TTH(J,k): peak position for jth peak (k=1 for alpha 1 & k=2 for 2)
C   * Display on IBM 3279
C
      YMIN=1000000.0
      YMAX=0.0
      DO 11 I=1,NOBS
      IF(YOB(I).GT.YMAX) YMAX=YOB(I)
   11 CONTINUE
      XLIM(1)=RTT(1)
      XLIM(2)=RTT(NOBS)
      YLIM(1)=-0.25*YMAX
      YLIM(2)=YMAX
      DO 12 I=1,NOBS
   12 DEF(I)=YOB(I)-YCL(I)-0.125*YMAX
        CALL PLOTS
        CALL PLOTCA (0.0,0.0,0.0)
        CALL PLOTCA (RTT(1),RTT(2))
        CALL PLOTYS (10.0)
C     Plot of Y(obs)'s
        CALL PLOTSM (1,1,1,1.00,0.015,0.015)
        CALL PLOTLN (1,0.05,0.05,0.05,0.0)
        CALL PLOTCA (RTT,YOB,NOBS,10.0,'2 THETA|','I (COUNTS)|',
     .   XLIM,YLIM,0)
        CALL PLOTSM (1,1,1,0.0,0.0,0.0)
C     Plot of Y(calc)'s
        CALL PLOTLN (1,1.0,0.0,1.0,0.1)
        CALL PLOTCA (RTT,YCL,NOBS,10.0,'|','|',XLIM,YLIM,-1)
C     Plot of Y(obs)-Y(calc)
        CALL PLOTLN (1,1.0,0.0,1.0,0.1)
        CALL PLOTCA (RTT,DEF,NOBS,10.0,'|','|',XLIM,YLIM,-1)
C     Plot of reflection-position markers
      DO 13 I=1,NREF
      XTT(I)=TTH(I,1)
   13 YTT(I)=-YMAX/33.33
        CALL PLOTSM (1,79,1,0.0,0.15,0.20)
        CALL PLOTLN (1,1.0,0.0,1.0,0.0)
        CALL PLOTCA (XTT,YTT,NREF,10.0,'|','|',XLIM,YLIM,-1)
        CALL PLOTCA (0.0,0.0,0.0)
      RETURN
      END
C
C
C
      SUBROUTINE OUTPUT
C     Output final parameters to the data file through file unit 22
      CHARACTER FLNAME*20,HPC*3
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/CONS/FWH(500),DRA(500,2),DDA(500,6),DAG(500,7,2),
     .            IDR(500,2,2),ASM(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      DIMENSION HPC(30)
      DATA HPC/   ' b1',' b2',' b3',' b4',' b5',' b6','  K','  e',' t1',
     .' t2',' t3','  a','  b','  c','alp','bet','gam',' w1',' w2',' w3',
     .' a1',' a2',' a3','rL1','rL2','rL3','rH1','rH2','rH3','Scl'/
  101 FORMAT(A20)
  102 FORMAT(10I5)
  103 FORMAT(6F10.3)
  104 FORMAT(6F10.6)
  105 FORMAT(5I5,2F10.2)
  211 FORMAT(/2X,'Final parameters (the e.s.d."s are on second lines)')
  212 FORMAT(/5X,6(7X,A3),2(/5X,6F10.3)/5X,5(7X,A3),2(/5X,5F10.6))
  213 FORMAT(/5X,'For',I3,'th component.')
  214 FORMAT(5X,6(7X,A3),2(/5X,6F10.6))
  215 FORMAT(5X,7X,A3,2(/5X,F10.6))
  221 FORMAT(/5X,'List of indices, d, Ij, and profile shape parmeters')
  222 FORMAT(/5X,'  N1  N2    h  k  l   MF',9X,'d',10X,'I    s(I)   Io')
  223 FORMAT(5X,2I4,2X,3I3,' (',I2,')',F10.5,F11.2,F8.2,I5)
  224 FORMAT(/5X,'  N1    TT(1)    TT(2)    d(TT)      FWHM   Asym   R(L
     .)   R(H)')
  225 FORMAT(5X,I4,2F9.3,F9.4,F10.4,3F7.2)
  231 FORMAT(//' Parameter output on file'//' Select a file name:'
     . //5X,'0: no output,   1: file A,   2: file B,   3: yor option.')
  232 FORMAT(//' Input file name for data output by /****** DAT.')
C
      DO 11 I=1,6
      XBG(I)=XBG(I)/SCAL
   11 SBG(I)=SBG(I)/SCAL
      WRITE(*,211)
      WRITE(*,212)  (HPC(I),I=1,6),(XBG(I),I=1,6),(SBG(I),I=1,6),
     . (HPC(I),I=7,11),(XBG(I),I=7,11),(SBG(I),I=7,11)
      WRITE(21,211)
      WRITE(21,212) (HPC(I),I=1,6),(XBG(I),I=1,6),(SBG(I),I=1,6),
     . (HPC(I),I=7,11),(XBG(I),I=7,11),(SBG(I),I=7,11)
      DO 13 K=1,NCOM
      WRITE(*,213)  K
      WRITE(21,213) K
      DO 12 N=1,3
      L=6*(N-1)+1
      M=L+5
      WRITE(*,214)  (HPC(I+11),I=L,M),(XPP(K,I),I=L,M),(SPP(K,I),I=L,M)
   12 WRITE(21,214) (HPC(I+11),I=L,M),(XPP(K,I),I=L,M),(SPP(K,I),I=L,M)
      WRITE(*,215)  HPC(30),XPP(K,19),SPP(K,19)
      WRITE(21,215) HPC(30),XPP(K,19),SPP(K,19)
   13 CONTINUE
C
      WRITE(*,221)
      WRITE(21,221)
      RIMX=0.0
      DO 21 I=1,IREF
      RIN(I,1)=RIN(I,1)/SCAL
      RIN(I,2)=RIN(I,2)/SCAL
      IF(RIN(I,1).GT.RIMX) RIMX=RIN(I,1)
   21 CONTINUE
      DO 23 K=1,NCOM
      WRITE(*,213)  K
      WRITE(21,213) K
      WRITE(*,222)
      WRITE(21,222)
      N=0
      DO 22 I=1,IREF
      IF(IMC(I).NE.K) GO TO 22
      N=N+1
      D=1.0/DSR(I)
      IF(RIMX.NE.0.0) THEN
        R=100.01*RIN(I,1)/RIMX
        IO=R
        IF(R-FLOAT(IO).GE.0.5) IO=IO+1
        ELSE
        IO=0
      END IF
      WRITE(*,223)  I,N,(IDX(I,J),J=1,3),NGM(I),D,(RIN(I,J),J=1,2),IO
      WRITE(21,223) I,N,(IDX(I,J),J=1,3),NGM(I),D,(RIN(I,J),J=1,2),IO
   22 CONTINUE
      WRITE(*,224)
      WRITE(21,224)
      DO 23 I=1,NREF
      N=JRF(I)
      IF(IMC(N).NE.K) GO TO 23
      WRITE(*,225)  N,(TTH(I,J),J=1,3),FWH(I),ASM(I),DRA(I,1),DRA(I,2)
      WRITE(21,225) N,(TTH(I,J),J=1,3),FWH(I),ASM(I),DRA(I,1),DRA(I,2)
   23 CONTINUE
C
      WRITE(*,231)
      READ(*,*) NF
      IF(NF.EQ.0) GO TO 41
      IF(NF-2) 31,32,33
   31 FLNAME='/WPPFA DAT A1'
      GO TO 34
   32 FLNAME='/WPPFB DAT A1'
      GO TO 34
   33 WRITE(*,232)
      READ(*,101) FLNAME
C
   34 OPEN(22,FILE=FLNAME,STATUS='UNKNOWN')
      WRITE(22,102) NCOM,IREF,(LAUE(I),I=1,5)
      WRITE(22,103) (XBG(I),I=1,6),(SBG(I),I=1,6)
      WRITE(22,104) (XBG(I),I=7,11)
      WRITE(22,104) (SBG(I),I=7,11)
      DO 35 K=1,NCOM
      WRITE(22,104) (XPP(K,I),I=1,6),  (SPP(K,I),I=1,6)
      WRITE(22,104) (XPP(K,I),I=7,12), (SPP(K,I),I=7,12)
      WRITE(22,104) (XPP(K,I),I=13,18),(SPP(K,I),I=13,18)
      WRITE(22,104) XPP(K,19)
   35 WRITE(22,104) SPP(K,19)
      DO 36 I=1,IREF
   36 WRITE(22,105) IMC(I),(IDX(I,J),J=1,3),NGM(I),(RIN(I,J),J=1,2)
      CLOSE(22)
C
   41 DO 42 I=1,6
      XBG(I)=XBG(I)*SCAL
   42 SBG(I)=SBG(I)*SCAL
      DO 43 I=1,IREF
      RIN(I,1)=RIN(I,1)*SCAL
   43 RIN(I,2)=RIN(I,2)*SCAL
      RETURN
      END
C
C
C
      SUBROUTINE DATAIN (STEP,RA12)
      CHARACTER SAMPLE*70,FLNAME*20,HWL*2
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/YDAT/TTRA,YOR(10001)
      DIMENSION HWL(7),DWL(6,3)
      DATA HWL/'Cu','Cr','Fe','Co','Mo','Ag','  '/
      DATA DWL/
     .  1.540562, 2.289700, 1.936042, 1.788965, 0.709300, 0.5594075,
     .  1.544390, 2.293606, 1.939980, 1.792850, 0.713590, 0.563798,
     .  0.497,    0.515,    0.500,    0.497,    0.499,    0.499/
  101 FORMAT(A20)
  102 FORMAT(A70)
  103 FORMAT(2I3,3F8.6,4F8.3)
  104 FORMAT(10F7.0)
  105 FORMAT(8F8.0)
  211 FORMAT(//' Input file name of intensity data by /****** DAT.')
  221 FORMAT(/' *********************** Profile intensity data *********
     .****************'//2X,'Sample:',A70//5X,'File name = ',A20,
     . ',  2theta range =',F7.3,' - ',F7.3,','
     . /5X,'Step width =',F6.3,',   Fixed time =',F6.1,
     . ',   Y(obs)i points =',I6,'.'
     . /5X,'Y(obs)max =',F9.0,' at 2-theta =',F7.2,','
     . /5X,'Y(obs)min =',F9.0,' at 2-theta =',F7.2,'.'
     . /5X,'The data were normalized to Y(obs) = 100*Y(obs)/Y(obs)max.'
     . /5X,'Radiation = ',A2,',   Lambda =',F9.6,' &',F9.6,
     . ',  IKa2/IKa1 =',F6.3,'.')
C
      WRITE(*,211)
      READ(*,101) FLNAME
      OPEN(11,FILE=FLNAME,STATUS='OLD')
      REWIND 11
      READ(11,102) SAMPLE
      READ(11,103) NFOR,NWVL,WVL1,WVL2,RA12,TTRA,TTRB,STEP,FIXT
      IOBS=(TTRB-TTRA+0.001)/STEP+1.0
      IF(NFOR.EQ.0) THEN
        READ(11,104) (YOR(I),I=1,IOBS)
        ELSE
        READ(11,105) (YOR(I),I=1,IOBS)
      END IF
      CLOSE(11)
      NWVL=NWVL+1
      IF(NWVL.LT.7) THEN
        WVL1=DWL(NWVL,1)
        WVL2=DWL(NWVL,2)
        RA12=DWL(NWVL,3)
      END IF
C
      YOMX=0.0
      YOMI=100000.0
      DO 11 I=1,IOBS
      YO=YOR(I)
      IF(YO.GE.YOMX) THEN
        YOMX=YO
        IX=I
      END IF
      IF(YO.LE.YOMI) THEN
        YOMI=YO
        IN=I
      END IF
   11 CONTINUE
      SCAL=100.0/YOMX
      TTMX=TTRA+FLOAT(IX-1)*STEP
      TTMI=TTRA+FLOAT(IN-1)*STEP
      WRITE(*,221)  SAMPLE,FLNAME,TTRA,TTRB,STEP,FIXT,IOBS,
     . YOMX,TTMX,YOMI,TTMI,HWL(NWVL),WVL1,WVL2,RA12
      WRITE(21,221) SAMPLE,FLNAME,TTRA,TTRB,STEP,FIXT,IOBS,
     . YOMX,TTMX,YOMI,TTMI,HWL(NWVL),WVL1,WVL2,RA12
      RETURN
      END
C
C
C
      SUBROUTINE PROCES (NOBS,PMAX,STEP)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/YDAT/TTRA,YOR(10001)
      COMMON/YOBS/NFBG,RTT(10001),YOB(10001),YCL(10001)
C
  211 FORMAT(/' ************************* Analysis conditions **********
     .****************')
  212 FORMAT(//' Set a 2-theta range to be analyzed.'
     .      //5X,'2-theta at  low angle side.')
  213 FORMAT( 5X,'2-theta at high angle side.')
  214 FORMAT(/5X,'Y(obs)i points =',I5,
     .  ',   Y(obs)max =',F9.0,',  Y(obs)min =',F7.0,
     .      /5X,'2-theta range        :',F8.3,' -',F8.3,'.')
  221 FORMAT(//' Select:'
     . //5X,'0: no process of Y(obs)i,   1: omit a part of Y(obs)i.')
  222 FORMAT(/5X,'Set a low  angle limit of the data to be omitted.')
  223 FORMAT(/5X,'Set a high angle limit of the data to be omitted.')
  224 FORMAT( 5X,'Y(obs)i are omitted in the range:',F7.2,'-',F7.2)
  231 FORMAT(//' Select a profile function.'
     . //5X,'0: Pearson VII,   1: pseudo-Voigt.')
  232 FORMAT(//' Select a profile shape modeling.'
     . //5X,'0: Ka1+Ka2 doublet,   1: singlet.')
  233 FORMAT(5X,'Profile function     : Pearson VII')
  234 FORMAT(5X,'Profile function     : pseudo-Voigt')
  235 FORMAT(5X,'Profile shape        : Ka1+Ka2 doublet')
  236 FORMAT(5X,'Profile shape        : singlet')
  237 FORMAT(//' Select a background function.'
     . //5X,'0: trigonometric,   1: polynomial.')
  238 FORMAT(5X,'Background function  : trigonometric')
  239 FORMAT(5X,'Background function  : polynomial')
C
      WRITE(*,211)
      WRITE(21,211)
      WRITE(*,212)
      READ(*,*) TTHA
      WRITE(*,213)
      READ(*,*) TTHB
      J=(TTHA-TTRA+0.0001)/STEP+1.0
      K=(TTHB-TTRA+0.0001)/STEP+1.0
      NOBS=K-J+1
      PMAX=0.0
      BAKL=100000.0
      N=0
      DO 11 I=J,K
      N=N+1
      RTT(N)=TTHA+STEP*FLOAT(N-1)
      YO=YOR(I)
      YOB(N)=SCAL*YO
      IF(YO.GT.PMAX) PMAX=YO
      IF(YO.LT.BAKL) BAKL=YO
   11 CONTINUE
      WRITE(21,214) NOBS,PMAX,BAKL,TTHA,TTHB
C
   21 WRITE(*,221)
      READ(*,*) NOMT
      IF(NOMT.EQ.0) GO TO 31
      WRITE(*,222)
      READ(*,*) TL
      WRITE(*,223)
      READ(*,*) TH
      J=(TL-TTHA+0.00001)/STEP+1.0
      K=(TH-TTHA+0.00001)/STEP+1.0
      DO 22 I=J,K
   22 YOB(I)=0.0
      WRITE(21,224) TL,TH
      GO TO 21
C
   31 WRITE(*,231)
      READ(*,*) NFNC
      IF(NFNC.NE.0) NFNC=1
      WRITE(*,232)
      READ(*,*) NSOD
      IF(NSOD.NE.0) NSOD=1
      IF(NSOD.EQ.0) NSOD=2
      IF(NFNC.EQ.0) WRITE(21,233)
      IF(NFNC.EQ.1) WRITE(21,234)
      IF(NSOD.EQ.2) WRITE(21,235)
      IF(NSOD.EQ.1) WRITE(21,236)
      WRITE(*,237)
      READ(*,*) NFBG
      IF(NFBG.NE.0) NFBG=1
      IF(NFBG.EQ.0) WRITE(21,238)
      IF(NFBG.EQ.1) WRITE(21,239)
      RETURN
      END
C
C
C
      SUBROUTINE GENERA (RA12)
C     Generation of initial parameters
      CHARACTER HLA*20
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      DIMENSION IEX(9),HLA(15),STP(6,4),ROE(4,2)
      DATA HLA/'Triclinic','Monoclinic (first)','Monoclinic (second)',
     .  'Orthorhombic','Tetragonal (4/m)','Tetragonal (4/mmm)',
     .  'Cubic (m3)','Cubic (m3m)','Rhombohedral (-3)',
     .  'Rhombohedral (-3m)','Trigonal (-3)','Trigonal (-3m1)',
     .  'Trigonal (-31m)','Hexagonal (6/m)','Hexagonal (6/mmm)'/
      DATA STP/
     ..0027,-.0009,.002,1.,.000, .000,  .0108,-.0037,.008,1.,.021,-.071,
     ..0470,-.0660,.123,1.,.021,-.071,  .1880,-.2640,.492,1.,.021,-.071/
      DATA ROE/ 2.5, 1.1, 1.2, 1.5, .50, .90, .80, .70/
      DATA RAD,DEG/0.01745329252E0,57.29577951E0/
C
  211 FORMAT(//' ********** Generation of initial parameter **********')
  212 FORMAT(//' Input the number of component in the sample.')
  213 FORMAT(//' Table of Laue groups'/15(/5X,I2,': ',A20))
  214 FORMAT(/5X,'Select a Laue group for',I2,'th component.')
  215 FORMAT(//' Select extinction rules for',I2,'th component.')
  221 FORMAT(/5X,'For hkl reflectins'/5X,'0: non',/5X,'1: h+k+l=2n'
     . /5X,'2: k+l=2n'/5X,'3: h+l=2n'/5X,'4: h+k=2n'
     . /5X,'5: h+k,k+l,l+h=2n'/5X,'6: -h+k+l=3n'/5X,'7:h-k+l=3n'
     . /5X,'8: h-k=3n')
  222 FORMAT(/5X,'For 0kl reflectins'/5X,'0: non',/5X,'1: k+l=2n'
     . /5X,'2: k+l=4n'/5X,'3: k=2n'/5X,'4: l=2n'/5X,'5: k,l=2n')
  223 FORMAT(/5X,'For h0l reflectins'/5X,'0: non',/5X,'1: h+l=2n'
     . /5X,'2: h+l=4n'/5X,'3: h=2n'/5X,'4: l=2n'/5X,'5: h,l=2n')
  224 FORMAT(/5X,'For hk0 reflectins'/5X,'0: non',/5X,'1: h+k=2n'
     . /5X,'2: h+k=4n'/5X,'3: h=2n'/5X,'4: k=2n'/5X,'5: h,k=2n')
  225 FORMAT(/5X,'For h00 reflectins'/5X,'0: non',/5X,'1: h=2n'
     . /5X,'2: h=4n')
  226 FORMAT(/5X,'For 0k0 reflectins'/5X,'0: non',/5X,'1: k=2n'
     . /5X,'2: k=4n')
  227 FORMAT(/5X,'For 00l reflectins'/5X,'0: non',/5X,'1: l=2n'
     . /5X,'2: l=4n'/5X,'3: l=3n'/5X,'4: l=6n')
  228 FORMAT(/5X,'For hhl reflectins'/5X,'0: non',/5X,'1: 2h+l=2n'
     . /5X,'2: 2h+l=4n'/5X,'3: l=3n'/5X,'4: l=2n'/5X,'5: h,l=2n'
     . /5X,'6: h+l=2n')
  229 FORMAT(/5X,'For h-hl reflectins'/5X,'0: non',/5X,'1:h-h+l=2n'
     . /5X,'2: 2h+l=6n'/5X,'3: 2h+l=3n'/5X,'4: l=2n')
  231 FORMAT(/5X,'Laue group : ',A20/5X,'Extinction rules for hkl  0kl
     .h0l  hk0  h00  0k0  00l  hhl h-hl'/23X,9I5)
  232 FORMAT(//' Input unit cell parameters for',I2,'th component')
  233 FORMAT(/5X,'a = ')
  234 FORMAT(/5X,'b = ')
  235 FORMAT(/5X,'c = ')
  236 FORMAT(/5X,'alpha = ')
  237 FORMAT(/5X,'beta  = ')
  238 FORMAT(/5X,'gamma = ')
  239 FORMAT( 5X,'The total number of reflections generated =',I5)
  251 FORMAT(//' Select a resolution of Yo data for',I3,'th component.'
     . //5X,'-1: ultra-sharp,   0: sharp,   1: medium,   2: broad.')
C
      WRITE(*,211)
      WRITE(*,212)
      READ(*,*) NCOM
      NR=0
      DO 17 K=1,NCOM
   11 WRITE(*,213) (I,HLA(I),I=1,15)
      WRITE(*,214) K
      READ(*,*) LA
      IF(LA.LT.0.OR.LA.GT.15) GO TO 11
      LAUE(K)=LA
      WRITE(*,215) K
      IEX(8)=0
      IEX(9)=0
      WRITE(*,221)
      READ(*,*) IEX(1)
      WRITE(*,222)
      READ(*,*) IEX(2)
      WRITE(*,223)
      READ(*,*) IEX(3)
      WRITE(*,224)
      READ(*,*) IEX(4)
      WRITE(*,225)
      READ(*,*) IEX(5)
      WRITE(*,226)
      READ(*,*) IEX(6)
      WRITE(*,227)
      READ(*,*) IEX(7)
      IF(LA.GT.4) THEN
        WRITE(*,228)
        READ(*,*) IEX(8)
        WRITE(*,229)
        READ(*,*) IEX(9)
      END IF
C
      WRITE(21,231) HLA(LA),(IEX(I),I=1,9)
      WRITE(*,232) K
      XPP(K,4)=90.0
      XPP(K,5)=90.0
      XPP(K,6)=90.0
      IF(LA.GT.10) XPP(K,6)=120.0
      WRITE(*,233)
      READ( *,*) XPP(K,1)
      IF(LA.GT.4) GO TO 12
      WRITE(*,234)
      READ( *,*) XPP(K,2)
   12 IF(LA.GT.6.AND.LA.LT.11) GO TO 13
      WRITE(*,235)
      READ( *,*) XPP(K,3)
   13 IF(LA.NE.1.AND.LA.NE.9.AND.LA.NE.10) GO TO 14
      WRITE(*,236)
      READ( *,*) XPP(K,4)
   14 IF(LA.NE.1.AND.LA.NE.3) GO TO 15
      WRITE(*,237)
      READ( *,*) XPP(K,5)
   15 IF(LA.NE.1.AND.LA.NE.2) GO TO 16
      WRITE(*,238)
      READ( *,*) XPP(K,6)
   16 IF(LA.GT.4) XPP(K,2)=XPP(K,1)
      IF(LA.GT.6.AND.LA.LT.11) XPP(K,3)=XPP(K,1)
      IF(LA.EQ.9.AND.LA.EQ.10) XPP(K,5)=XPP(K,4)
      IF(LA.EQ.9.AND.LA.EQ.10) XPP(K,6)=XPP(K,4)
C
      DL=2.0*SIN(0.5*RAD*TTHA)/WVL1
      IF(NSOD.EQ.2) THEN
        DU=2.0*SIN(0.5*RAD*TTHB)/WVL2
        ELSE
        DU=2.0*SIN(0.5*RAD*TTHB)/WVL1
      END IF
      AA=XPP(K,1)
      BB=XPP(K,2)
      CC=XPP(K,3)
      CA=COS(RAD*XPP(K,4))
      CB=COS(RAD*XPP(K,5))
      CG=COS(RAD*XPP(K,6))
      SA=SIN(RAD*XPP(K,4))
      SB=SIN(RAD*XPP(K,5))
      SG=SIN(RAD*XPP(K,6))
      DA=CB*CG-CA
      DB=CG*CA-CB
      DG=CA*CB-CG
      DV=1.0-CA*CA-CB*CB-CG*CG+2.0*CA*CB*CG
      SV=SQRT(DV)
      AS=SA/(AA*SV)
      BS=SB/(BB*SV)
      CS=SG/(CC*SV)
      GA=2.0*DA/(SB*SG)
      GB=2.0*DB/(SG*SA)
      GG=2.0*DG/(SA*SB)
C
      CALL INDEXS (K,NR,LA,IEX,DL,DU,AS,BS,CS,GA,GB,GG)
C
   17 CONTINUE
      IREF=NR
      WRITE(*,239)  IREF
      WRITE(21,239) IREF
      DO 18 I=1,IREF
   18 XRP(I)=0.0
C
      CALL ARANGE
C
      DO 21 I=1,11
   21 XBG(I)=0.0
      XBG(7)=RA12
      IF(NSOD.EQ.1) XBG(7)=0.0
      DO 25 K=1,NCOM
      DO 22 I=7,19
   22 XPP(K,I)=0.0
   23 WRITE(*,251) K
      READ(*,*) NRSL
      IF(NRSL.LT.-1.OR.NRSL.GT.2) GO TO 23
      NRSL=NRSL+2
      DO 24 I=7,12
      XPP(K,I)=STP(I-6,NRSL)
      XPP(K,13)=ROE(NRSL,NFNC+1)
      XPP(K,16)=ROE(NRSL,NFNC+1)
   24 XPP(K,19)=1.0
   25 CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE PARAME
C     Input initial parameters from data file through file unit 12
      CHARACTER FLNAME*20
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
C
  101 FORMAT(A20)
  102 FORMAT(10I5)
  103 FORMAT(6F10.3)
  104 FORMAT(6F10.6)
  105 FORMAT(5I5,2F10.2)
  211 FORMAT(//' ********** Input of initial parameters **********'
     . //' Select a file name:'
     . //5X,'0: file A,   1: file B,   2: your option.')
  212 FORMAT(//' Input file name for data input by /****** DAT.')
C
      WRITE(*,211)
      READ(*,*) NF
      IF(NF-1) 11,12,13
   11 FLNAME='/WPPFA DAT A1'
      GO TO 21
   12 FLNAME='/WPPFB DAT A1'
      GO TO 21
   13 WRITE(*,212)
      READ(*,101) FLNAME
C
   21 OPEN(12,FILE=FLNAME,STATUS='OLD')
      REWIND 12
      READ(12,102) NCOM,IREF,(LAUE(I),I=1,5)
      READ(12,103) (XBG(I),I=1,6),(SBG(I),I=1,6)
      READ(12,104) (XBG(I),I=7,11)
      READ(12,104) (SBG(I),I=7,11)
      DO 22 I=1,6
      XBG(I)=SCAL*XBG(I)
   22 SBG(I)=SCAL*SBG(I)
      DO 23 K=1,NCOM
      READ(12,104) (XPP(K,I),I=1,6)  ,(SPP(K,I),I=1,6)
      READ(12,104) (XPP(K,I),I=7,12) ,(SPP(K,I),I=7,12)
      READ(12,104) (XPP(K,I),I=13,18),(SPP(K,I),I=13,18)
      READ(12,104) XPP(K,19)
   23 READ(12,104) SPP(K,19)
      DO 24 I=1,IREF
      READ(12,105) IMC(I),(IDX(I,J),J=1,3),NGM(I),(RIN(I,J),J=1,2)
      RIN(I,1)=SCAL*RIN(I,1)
      RIN(I,2)=SCAL*RIN(I,2)
   24 CONTINUE
      CLOSE(12)
      RETURN
      END
C
C
C
      SUBROUTINE CORECT (IJOB,NSET,PMAX,DRPF,GRUP)
      CHARACTER HPC*3
      COMMON/PARA/XBG(11),SBG(11),XPP(5,19),SPP(5,19),XRP(500),SRP(500)
      COMMON/CNST/NCOM,NREF,NFNC,NSOD,LAUE(5),TTHA,TTHB,WVL1,WVL2,SCAL
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      COMMON/TTHX/JRF(500),MLT(500),TTH(500,3)
      COMMON/DUMP/DMP(2)
      DIMENSION HPC(30),NTP(20)
      DATA HPC/   ' b1',' b2',' b3',' b4',' b5',' b6','  K','  e',' t1',
     .' t2',' t3','  a','  b','  c','alp','bet','gam',' w1',' w2',' w3',
     .' a1',' a2',' a3','rL1','rL2','rL3','rH1','rH2','rH3','Scl'/
C
  211 FORMAT(//' ********** Correction of initial parameters **********'
     .//5X,'For correction of parameter value,'
     . /5X,'input zero for no correction,'
     . /5X,'input a new parameter to correct it, and'
     . /5X,'input 0.00001 when new parameter is zero.'//5X,
     . 'Select:'//5X,'0: no corrcetion,   1: correct reflection table,'
     .           /5X,'2: correct profile parameters,   3: end.')
  221 FORMAT(//'********** Reflection table **********'
     . //7X,'No. Component    h   k   l       Intensity')
  222 FORMAT(5X,I4,3X,I4,5X,3I4,4X,F12.3)
  223 FORMAT(//5X,'Select:'//5X,'0: no correction,  1: omit reflection,
     . 2: change intensity.')
  224 FORMAT(/5X,'Input a number of reflection to be omited or changed'
     . /5X,'(Input zero to finish).'/)
  225 FORMAT( 5X,'Number = ')
  226 FORMAT( 5X,'I =',F10.2,' for',I4,'th reflex.   New parameter = ')
  231 FORMAT(//' ********** Table of initial parameters **********')
  232 FORMAT(/5X,6(7X,A3)/5X,6F10.3/5X,5(7X,A3)/5X,5F10.6)
  233 FORMAT(/5X,'Select   0: no correction,  1: correct parameter.')
  234 FORMAT( 5X,'Parameter ',A3,' =',F12.5,'.   New parameter = ')
  235 FORMAT(//' For',I3,'th component.'/)
  236 FORMAT(5X,6(7X,A3)/5X,6F10.5)
  237 FORMAT(5X,7X,A3/5X,F10.5)
  241 FORMAT(//' I*P(x) is calculated for > I*P(x)limit.'//5X,'Input I*P
     .(x)limit in counts (default =',F7.1,' counts).')
  243 FORMAT(//' Too closely overlapping reflections within a width D ar
     .e'/5X,'grouped together, and refined as one reflection.'
     . //5X,'Select:  0: no grouping,   1: grouping A,   2: grouping B.'
     . //5X,'D is 2-theta angle independent in grouping A.'
     .  /5X,'D has a form D=D*FWHM/FWHM(at 2theta=30) in grouping B.')
  244 FORMAT(/5X,'Input the width D (2-theta in degree).')
  242 FORMAT(/5X,'I*P(x)limit (counts) :',F7.1)
  245 FORMAT( 5X,'Grouping width (deg) :',F7.3,' (angle-independent).')
  246 FORMAT( 5X,'Grouping width (deg) :',F7.3,' (angle-dependent).')
  247 FORMAT( 5X,'The number of reflex :',I7)
  251 FORMAT(//' Select:'//5X,'0: no dumping for parameter change,'
     . /5X,'1: apply dumping factor.')
  252 FORMAT(/' Dumping factor for linear parameters (I,b,S) =')
  253 FORMAT(/' Dumping factor for non-linear parameters     =')
  254 FORMAT(/5X,'Dumping factors for I,b,S =',F6.3,',  for P.P.=',F6.3)
C
   11 IJOB=1
      WRITE(*,211)
      READ(*,*) NCOR
      IF(NCOR.GT.2) THEN
        IJOB=-1
        GO TO 61
      END IF
      IF(NCOR-1) 51,21,41
C
   21 DO 22 I=1,IREF
      RIN(I,1)=RIN(I,1)/SCAL
   22 RIN(I,2)=RIN(I,2)/SCAL
      L=(IREF-1)/15+1
      DO 29 II=1,L
   23 WRITE(*,221)
      I1=15*(II-1)+1
      I2=I1+14
      IF(I2.GT.IREF) I2=IREF
      DO 24 I=I1,I2
      IF(IMC(I).NE.0) WRITE(*,222) I,IMC(I),(IDX(I,J),J=1,3),RIN(I,1)
   24 CONTINUE
      WRITE(*,223)
      READ(*,*) ND
      IF(ND-1) 29,25,28
   25 N=0
      WRITE(*,224)
   26 N=N+1
      WRITE(*,225)
      READ(*,*) NTP(N)
      IF(NTP(N).NE.0) THEN
        GO TO 26
        ELSE
        IF(N.EQ.1) GO TO 23
        DO 27 J=1,N-1
        M=NTP(J)
   27   IMC(M)=0
        GO TO 23
      END IF
   28 WRITE(*,225)
      READ(*,*) N
      IF(N.EQ.0) GO TO 23
      WRITE(*,226) RIN(N,1),N
      READ(*,*) DP
      IF(DP.LT.0.00002) DP=0.0
      RIN(N,1)=DP
      GO TO 28
   29 CONTINUE
C
      N=0
      DO 31 I=1,IREF
      IF(IMC(I).EQ.0) GO TO 31
      N=N+1
      IMC(N)=IMC(I)
      NGM(N)=NGM(I)
      IDX(N,1)=IDX(I,1)
      IDX(N,2)=IDX(I,2)
      IDX(N,3)=IDX(I,3)
      RIN(N,1)=RIN(I,1)*SCAL
      RIN(N,2)=RIN(I,2)*SCAL
   31 CONTINUE
      IREF=N
      GO TO 11
C
   41 DO 42 I=1,6
   42 XBG(I)=XBG(I)/SCAL
      WRITE(*,231)
   43 WRITE(*,232) (HPC(I),I=1,6),(XBG(I),I=1,6),(HPC(I),I=7,11),
     . (XBG(I),I=7,11)
      WRITE(*,233)
      READ(*,*) ND
      IF(ND.EQ.0) GO TO 45
      DO 44 I=1,11
      WRITE(*,234) HPC(I),XBG(I)
      READ(*,*) DP
      IF(DP.EQ.0.0) GO TO 44
      IF(DP.LT.0.00002) DP=0.0
      XBG(I)=DP
   44 CONTINUE
      GO TO 43
   45 DO 48 K=1,NCOM
   46 WRITE(*,235) K
      WRITE(*,236) (HPC(I),I=12,17),(XPP(K,I),I=1,6)
      WRITE(*,236) (HPC(I),I=18,23),(XPP(K,I),I=7,12)
      WRITE(*,236) (HPC(I),I=24,29),(XPP(K,I),I=13,18)
      WRITE(*,237) HPC(30),XPP(K,19)
      WRITE(*,233)
      READ(*,*) ND
      IF(ND.EQ.0) GO TO 48
      DO 47 I=1,19
      WRITE(*,234) HPC(I+11),XPP(K,I)
      READ(*,*) DP
      IF(DP.EQ.0.0) GO TO 47
      IF(DP.LT.0.00002) DP=0.0
      XPP(K,I)=DP
   47 CONTINUE
      GO TO 46
   48 CONTINUE
      DO 49 I=1,6
   49 XBG(I)=XBG(I)*SCAL
      GO TO 11
C
   51 DRPF=DRPF/SCAL
      IF(DRPF.EQ.0.0) DRPF=0.001*PMAX
      WRITE(*,241) DRPF
      READ(*,*) ER
      IF(ER.NE.0.0) DRPF=ER
      WRITE(21,242) DRPF
      DRPF=DRPF*SCAL
      WRITE(*,243)
      READ(*,*) NSET
      IF(NSET.NE.0) THEN
        WRITE(*,244)
        READ(*,*) GRUP
      END IF
      IF(NSET.EQ.0) GRUP=0.0001
      IF(NSET.LE.1) WRITE(21,245) GRUP
      IF(NSET.GT.1) WRITE(21,246) GRUP
      WRITE(*,247)  IREF
      WRITE(21,247) IREF
C
      DO 52 I=1,2
   52 DMP(I)=1.0
      WRITE(*,251)
      READ(*,*) ND
      IF(ND.EQ.0) GO TO 61
      WRITE(*,252)
      READ(*,*) DP
      IF(DP.NE.0.0) DMP(1)=DP
      WRITE(*,253)
      READ(*,*) DP
      IF(DP.NE.0.0) DMP(2)=DP
      WRITE(21,254) (DMP(I),I=1,2)
   61 RETURN
      END
C
C
C
      SUBROUTINE INDEXS (K,NR,LA,IEX,DL,DU,AS,BS,CS,GA,GB,GG)
C     Subroutine for generating indices of reflections.
      COMMON/SAVE/IREF,IMC(500),NGM(500),IDX(500,3),RIN(500,2),DSR(500)
      DIMENSION NOE(2,2,2),NGD(15,10),IEX(9)
      DATA NOE(1,1,1),NOE(2,1,1),NOE(1,2,1),NOE(1,1,2),NOE(1,2,2),
     1     NOE(2,1,2),NOE(2,2,1)/1,2,3,4,5,6,7/
      DATA ((NGD(I,J),J=1,10),I=1,15)/
     1  2, 2, 2, 2, 2, 2, 2, 0, 0, 0,   4, 4, 4, 2, 2, 2, 2, 0, 0, 0,
     2  4, 4, 2, 4, 2, 2, 2, 0, 0, 0,   8, 4, 4, 4, 2, 2, 2, 0, 0, 0,
     3  8, 0, 8, 4, 4, 0, 2, 0, 0, 0,  16, 0, 8, 8, 4, 0, 2, 0, 8, 4,
     4 24, 0,12,12, 6, 0, 0, 8,24,12,  48, 0, 0,24, 6, 0, 0, 8,24,12,
     5  6, 6, 6, 6, 6, 6, 6, 2, 6, 6,  12, 0,12,12, 6, 0, 0, 2, 6, 6,
     6  6, 0, 6, 6, 6, 0, 2, 0, 6, 6,  12, 6, 6,12, 6, 0, 2, 0,12, 6,
     7 12, 0,12,12, 6, 0, 2, 0, 6, 6,  12, 0,12, 6, 6, 0, 2, 0,12, 6,
     8 24, 0,12,12, 6, 0, 2, 0,12, 6/
      NNNN=500
C
  211 FORMAT(/5X,'Multiplicity factors'/
     1   5X,'hkl  0kl  h0l  hk0  h00  0k0  00l  hhh  hhl  hh0'/3X,10I5)
  212 FORMAT(/5X,'Dimension over in the subroutine INDEXS !!!')
C
      WRITE(*,211) (NGD(LA,I),I=1,10)
      MH=DU/AS+1.0
      MK=DU/BS+1.0
      ML=DU/CS+1.0
      N=0
      IL=-1
      IF(LA.GE.9.AND.LA.LE.11.OR.LA.EQ.13) IL=-ML-1
   11 IL=IL+1
      IF(IL-ML) 12,12,81
   12 IK=-1
      IF(LA.EQ.1.OR.LA.EQ.9.OR.LA.EQ.10)   IK=-MK-1
   13 IK=IK+1
      IF(IK-MK) 14,14,11
   14 IH=-1
      IF(LA.LE.3.OR.LA.EQ.9.OR.LA.EQ.10)   IH=-MH-1
   15 IH=IH+1
      IF(IH-MH) 16,16,13
   16 GO TO (20,21,22,35,23,24,25,26,27,27,31,32,33,23,24),LA
   20 IF(IL.EQ.0.AND.IK.LT.0)   GO TO 15
      IF(IL.EQ.0.AND.IK.EQ.0.AND.IH.LT.0)   GO TO 15
      GO TO 35
   21 IF(IK.EQ.0.AND.IH.LT.0)   GO TO 15
      GO TO 35
   22 IF(IL.EQ.0.AND.IH.LT.0)   GO TO 15
      GO TO 35
   23 IF(IH.EQ.0.AND.IK.GT.0)   GO TO 15
      GO TO 35
   24 IF(IH-IK) 15,35,35
   25 IF(IH.LT.IK. OR.IH.LT.IL) GO TO 15
      IF(IH.EQ.IL.AND.IH.NE.IK) GO TO 15
      GO TO 35
   26 IF(IH.GE.IK.AND.IK.GE.IL) GO TO 35
      GO TO 15
   27 IF(IH.GE.IK.AND.IK.GE.IL) GO TO 28
      GO TO 15
   28 IF(LA-10) 29,30,15
   29 IF(LA.LT.5.AND.IH.EQ.IK.AND.IK.NE.IL) GO TO 15
      IF(IH.EQ.IK.AND.IK.EQ.IL.AND.IL.LT.0) GO TO 15
      GO TO 35
   30 IF(IH+IK+IL) 15,35,35
   31 IF(IH.EQ.0.AND.IK.EQ.0.AND.IL.LT.0)   GO TO 15
      GO TO 23
   32 IF(IL.EQ.0.AND.IH.LT.IK)  GO TO 15
      GO TO 35
   33 IF(IH.GE.0.AND.IK.EQ.0.AND.IL.LT.0)   GO TO 15
      GO TO 24
   35 RH=FLOAT(IH)*AS
      RK=FLOAT(IK)*BS
      RL=FLOAT(IL)*CS
      DS=RH*RH+RK*RK+RL*RL+RK*RL*GA+RL*RH*GB+RH*RK*GG
      DS=SQRT(DS)
      IF(DS.LT.DL.OR.DS.GT.DU)  GO TO 15
C
      JH=(IABS(IH)+2)/(IABS(IH)+1)
      JK=(IABS(IK)+2)/(IABS(IK)+1)
      JL=(IABS(IL)+2)/(IABS(IL)+1)
      IR=NOE(JH,JK,JL)
      KR=IR
      IF(IR.NE.1) GO TO 36
      IF(IEX(8).NE.0.AND.IH.EQ.IK)   KR=8
      IF(IEX(9).NE.0.AND.IH+IK.EQ.0) KR=9
   36 IX=IEX(KR)+1
      JI=IH+IK+IL
      GO TO (71,56,37,38,39,65,51,53,54),IX
   37 GO TO (40,58,58,58,58,58,58,58,48),KR
   38 GO TO (41,44,43,43,15,15,46,46,48),KR
   39 GO TO (42,45,45,44,15,15,47,45,45),KR
   40 JI=IK+IL
      GO TO 56
   41 JI=IL+IH
      GO TO 56
   42 JI=IH+IK
      GO TO 56
   43 JI=IH
      GO TO 56
   44 JI=IK
      GO TO 56
   45 JI=IL
      GO TO 56
   46 JI=IL
      GO TO 57
   47 JI=IL
      GO TO 59
   48 JI=2*IH+IL
      IF(IX-3) 59,59,57
   51 IF(KR-1) 52,52,41
   52 JI=-IH+IK+IL
      GO TO 57
   53 JI=IH-IK+IL
      GO TO 57
   54 JI=IH-IK
      GO TO 57
   56 ND=2
      GO TO 60
   57 ND=3
      GO TO 60
   58 ND=4
      GO TO 60
   59 ND=6
   60 IF(MOD(JI,ND)) 15,71,15
   65 GO TO (66,67,67,67,15,15,15,67,15),KR
   66 JH=IK+IL
      JK=IL+IH
      JL=IH+IK
      GO TO 68
   67 JH=IH
      JK=IK
      JL=IL
   68 KH=MOD(JH,2)
      KK=MOD(JK,2)
      KL=MOD(JL,2)
      IF(IABS(KH)+IABS(KK)+IABS(KL)) 15,71,15
C
C     Assign multiplicity factor
C
   71 JR=IR
      IF(JR.NE.1.AND.JR.NE.3.AND.JR.NE.4) GO TO 78
      GO TO (78,78,78,78,78,72,73,73,73,73,78,72,72,78,72),LA
   72 IF(IR.EQ. 1.AND.IH.EQ.IK) JR= 9
      IF(IR.EQ. 4.AND.IH.EQ.IK) JR=10
      GO TO 78
   73 IF(IH.EQ.IK.AND.IK.EQ.IL) JR= 8
      IF(IH.EQ.IK.AND.IK.NE.IL) JR= 9
      IF(IH.EQ.IK.AND.IL.EQ. 0) JR=10
      IF(LA.EQ. 8) GO TO 74
      IF(LA.EQ.10) GO TO 75
      GO TO 78
   74 IF(IK.EQ.IL.AND.IH.NE.IL) JR= 9
      GO TO 78
   75 IF(IK.EQ.IL.AND.IH.NE.IK) JR= 9
      IF(IH+IK+IL.EQ.0)         JR=10
   78 IG=NGD(LA,JR)
      IF(IG.EQ.0) GO TO 15
C
      NR=NR+1
      IF(NR.GT.NNNN) WRITE(*,212)
      IMC(NR)=K
      IDX(NR,1)=IH
      IDX(NR,2)=IK
      IDX(NR,3)=IL
      NGM(NR)=IG
      RIN(NR,1)=0.0
      RIN(NR,2)=0.0
      GO TO 15
   81 RETURN
      END
C----------- The end of File WPPF FORTRAN ----------------------------
C
C
C
C----------- The end of Mail -----------------------------------------
